/********************************************************************
	Rhapsody	: 7.4 
	Login		: westphal
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: C
//!	Generated Date	: Wed, 16, Jan 2013  
	File Path	: DefaultComponent\DefaultConfig\C.cpp
*********************************************************************/

//#[ ignore
#define NAMESPACE_PREFIX

#define _OMSTATECHART_ANIMATED
//#]

//## auto_generated
#include "C.h"
//#[ ignore
#define Default_C_C_SERIALIZE OM_NO_OP
//#]

//## package Default

//## class C
C::C(IOxfActive* theActiveContext) : X(0) {
    NOTIFY_REACTIVE_CONSTRUCTOR(C, C(), 0, Default_C_C_SERIALIZE);
    setActiveContext(theActiveContext, false);
    {
        {
            itsD.setShouldDelete(false);
        }
        itsD.setActiveContext(theActiveContext, false);
    }
    itsD_1 = NULL;
    m = NULL;
    initRelations();
    initStatechart();
}

C::~C() {
    NOTIFY_DESTRUCTOR(~C, true);
    cleanUpRelations();
}

int C::getX() const {
    return X;
}

void C::setX(int p_X) {
    X = p_X;
}

D* C::getItsD() const {
    return (D*) &itsD;
}

D* C::getItsD_1() const {
    return itsD_1;
}

void C::setItsD_1(D* p_D) {
    itsD_1 = p_D;
    if(p_D != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED("itsD_1", p_D, false, true);
        }
    else
        {
            NOTIFY_RELATION_CLEARED("itsD_1");
        }
}

D* C::getM() const {
    return m;
}

void C::setM(D* p_D) {
    m = p_D;
    if(p_D != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED("m", p_D, false, true);
        }
    else
        {
            NOTIFY_RELATION_CLEARED("m");
        }
}

bool C::startBehavior() {
    bool done = true;
    done &= itsD.startBehavior();
    done &= OMReactive::startBehavior();
    return done;
}

void C::initRelations() {
    itsD._setItsC(this);
}

void C::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
}

void C::cleanUpRelations() {
    if(itsD_1 != NULL)
        {
            NOTIFY_RELATION_CLEARED("itsD_1");
            itsD_1 = NULL;
        }
    if(m != NULL)
        {
            NOTIFY_RELATION_CLEARED("m");
            m = NULL;
        }
}

void C::destroy() {
    itsD.destroy();
    OMReactive::destroy();
}

void C::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        NOTIFY_TRANSITION_STARTED("0");
        NOTIFY_STATE_ENTERED("ROOT.S1");
        rootState_subState = S1;
        rootState_active = S1;
        NOTIFY_TRANSITION_TERMINATED("0");
    }
}

IOxfReactive::TakeEventStatus C::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        case S1:
        {
            if(IS_EVENT_TYPE_OF(E_Default_id))
                {
                    OMSETPARAMS(E);
                    //## transition 1 
                    if(true)
                        {
                            NOTIFY_TRANSITION_STARTED("1");
                            NOTIFY_STATE_EXITED("ROOT.S1");
                            //#[ transition 1 
                            m -> GEN(F);
                            this->X= 1;
                            //#]
                            NOTIFY_STATE_ENTERED("ROOT.S2");
                            pushNullTransition();
                            rootState_subState = S2;
                            rootState_active = S2;
                            NOTIFY_TRANSITION_TERMINATED("1");
                            res = eventConsumed;
                        }
                }
            
            break;
        }
        case S2:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    //## transition 2 
                    if(X=0)
                        {
                            NOTIFY_TRANSITION_STARTED("2");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.S2");
                            NOTIFY_STATE_ENTERED("ROOT.S3");
                            rootState_subState = S3;
                            rootState_active = S3;
                            NOTIFY_TRANSITION_TERMINATED("2");
                            res = eventConsumed;
                        }
                }
            
            break;
        }
        
        default:
            break;
    }
    return res;
}

#ifdef _OMINSTRUMENT
//#[ ignore
void OMAnimatedC::serializeAttributes(AOMSAttributes* aomsAttributes) const {
    aomsAttributes->addAttribute("X", x2String(myReal->X));
}

void OMAnimatedC::serializeRelations(AOMSRelations* aomsRelations) const {
    aomsRelations->addRelation("itsD", true, true);
    aomsRelations->ADD_ITEM(&myReal->itsD);
    aomsRelations->addRelation("itsD_1", false, true);
    if(myReal->itsD_1)
        {
            aomsRelations->ADD_ITEM(myReal->itsD_1);
        }
    aomsRelations->addRelation("m", false, true);
    if(myReal->m)
        {
            aomsRelations->ADD_ITEM(myReal->m);
        }
}

void OMAnimatedC::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case C::S1:
        {
            S1_serializeStates(aomsState);
            break;
        }
        case C::S2:
        {
            S2_serializeStates(aomsState);
            break;
        }
        case C::S3:
        {
            S3_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedC::S3_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.S3");
}

void OMAnimatedC::S2_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.S2");
}

void OMAnimatedC::S1_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.S1");
}
//#]

IMPLEMENT_REACTIVE_META_P(C, Default, Default, false, OMAnimatedC)
#endif // _OMINSTRUMENT

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\C.cpp
*********************************************************************/
