/*********************************************************************
	Rhapsody	: 7.4 
	Login		: westphal
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: C
//!	Generated Date	: Wed, 16, Jan 2013  
	File Path	: DefaultComponent\DefaultConfig\C.h
*********************************************************************/

#ifndef C_H
#define C_H

//## auto_generated
#include <oxf\oxf.h>
//## auto_generated
#include "Default.h"
//## auto_generated
#include <oxf\omreactive.h>
//## auto_generated
#include <oxf\state.h>
//## auto_generated
#include <oxf\event.h>
//## link itsD
#include "D.h"
//## auto_generated
#include <aom\aom.h>
//## auto_generated
#include <oxf\omthread.h>
//## package Default

//## class C
class C : public OMReactive {
public :

#ifdef _OMINSTRUMENT
    friend class OMAnimatedC;
#endif // _OMINSTRUMENT

    ////    Constructors and destructors    ////
    
    //## auto_generated
    C(IOxfActive* theActiveContext = 0);
    
    //## auto_generated
    ~C();
    
    ////    Additional operations    ////
    
    //## auto_generated
    int getX() const;
    
    //## auto_generated
    void setX(int p_X);
    
    //## auto_generated
    D* getItsD() const;
    
    //## auto_generated
    D* getItsD_1() const;
    
    //## auto_generated
    void setItsD_1(D* p_D);
    
    //## auto_generated
    D* getM() const;
    
    //## auto_generated
    void setM(D* p_D);
    
    int X;		//## attribute X
    
    //## auto_generated
    virtual bool startBehavior();

protected :

    //## auto_generated
    void initRelations();
    
    //## auto_generated
    void initStatechart();
    
    //## auto_generated
    void cleanUpRelations();
    
    ////    Attributes    ////
    
    ////    Relations and components    ////
    
    D itsD;		//## link itsD
    
    D* itsD_1;		//## link itsD_1
    
    D* m;		//## link m
    
    ////    Framework operations    ////

public :

    //## auto_generated
    void destroy();
    
    ////    Framework    ////
    
    // rootState:
    //## statechart_method
    inline bool rootState_IN() const;
    
    //## statechart_method
    virtual void rootState_entDef();
    
    //## statechart_method
    virtual IOxfReactive::TakeEventStatus rootState_processEvent();
    
    // S3:
    //## statechart_method
    inline bool S3_IN() const;
    
    // S2:
    //## statechart_method
    inline bool S2_IN() const;
    
    // S1:
    //## statechart_method
    inline bool S1_IN() const;

protected :

//#[ ignore
    enum C_Enum {
        OMNonState = 0,
        S3 = 1,
        S2 = 2,
        S1 = 3
    };
    
    int rootState_subState;
    
    int rootState_active;
//#]
};

#ifdef _OMINSTRUMENT
//#[ ignore
class OMAnimatedC : virtual public AOMInstance {
    DECLARE_REACTIVE_META(C, OMAnimatedC)
    
    ////    Framework operations    ////
    
public :

    virtual void serializeAttributes(AOMSAttributes* aomsAttributes) const;
    
    virtual void serializeRelations(AOMSRelations* aomsRelations) const;
    
    //## statechart_method
    void rootState_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void S3_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void S2_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void S1_serializeStates(AOMSState* aomsState) const;
};
//#]
#endif // _OMINSTRUMENT

inline bool C::rootState_IN() const {
    return true;
}

inline bool C::S3_IN() const {
    return rootState_subState == S3;
}

inline bool C::S2_IN() const {
    return rootState_subState == S2;
}

inline bool C::S1_IN() const {
    return rootState_subState == S1;
}

#endif
/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\C.h
*********************************************************************/
