/********************************************************************
	Rhapsody	: 7.4 
	Login		: westphal
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: C
//!	Generated Date	: Wed, 16, Jan 2013  
	File Path	: DefaultComponent\DefaultConfig\C.cpp
*********************************************************************/

//#[ ignore
#define NAMESPACE_PREFIX

#define _OMSTATECHART_ANIMATED
//#]

//## auto_generated
#include "C.h"
//## link itsD
#include "D.h"
//## link itsR
#include "R.h"
//#[ ignore
#define Default_C_C_SERIALIZE OM_NO_OP
//#]

//## package Default

//## class C
C::C(IOxfActive* theActiveContext) : x(0) {
    NOTIFY_REACTIVE_CONSTRUCTOR(C, C(), 0, Default_C_C_SERIALIZE);
    setActiveContext(theActiveContext, false);
    itsD = NULL;
    itsR = NULL;
    initStatechart();
}

C::~C() {
    NOTIFY_DESTRUCTOR(~C, true);
    cleanUpRelations();
}

int C::getX() const {
    return x;
}

void C::setX(int p_x) {
    x = p_x;
}

D* C::getItsD() const {
    return itsD;
}

void C::setItsD(D* p_D) {
    itsD = p_D;
    if(p_D != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED("itsD", p_D, false, true);
        }
    else
        {
            NOTIFY_RELATION_CLEARED("itsD");
        }
}

R* C::getItsR() const {
    return itsR;
}

void C::setItsR(R* p_R) {
    _setItsR(p_R);
}

bool C::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

void C::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
}

void C::cleanUpRelations() {
    if(itsD != NULL)
        {
            NOTIFY_RELATION_CLEARED("itsD");
            itsD = NULL;
        }
    if(itsR != NULL)
        {
            NOTIFY_RELATION_CLEARED("itsR");
            itsR = NULL;
        }
}

void C::__setItsR(R* p_R) {
    itsR = p_R;
    if(p_R != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED("itsR", p_R, false, true);
        }
    else
        {
            NOTIFY_RELATION_CLEARED("itsR");
        }
}

void C::_setItsR(R* p_R) {
    __setItsR(p_R);
}

void C::_clearItsR() {
    NOTIFY_RELATION_CLEARED("itsR");
    itsR = NULL;
}

void C::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        NOTIFY_TRANSITION_STARTED("0");
        NOTIFY_STATE_ENTERED("ROOT.s1");
        rootState_subState = s1;
        rootState_active = s1;
        NOTIFY_TRANSITION_TERMINATED("0");
    }
}

IOxfReactive::TakeEventStatus C::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        case s1:
        {
            if(IS_EVENT_TYPE_OF(E_Default_id))
                {
                    NOTIFY_TRANSITION_STARTED("2");
                    NOTIFY_STATE_EXITED("ROOT.s1");
                    //#[ transition 2 
                    getItsD()->GEN(F);
                    setX(1);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.s2");
                    pushNullTransition();
                    rootState_subState = s2;
                    rootState_active = s2;
                    NOTIFY_TRANSITION_TERMINATED("2");
                    res = eventConsumed;
                }
            
            break;
        }
        case s2:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    //## transition 1 
                    if(x==0)
                        {
                            NOTIFY_TRANSITION_STARTED("1");
                            popNullTransition();
                            NOTIFY_STATE_EXITED("ROOT.s2");
                            NOTIFY_STATE_ENTERED("ROOT.s3");
                            rootState_subState = s3;
                            rootState_active = s3;
                            NOTIFY_TRANSITION_TERMINATED("1");
                            res = eventConsumed;
                        }
                }
            
            break;
        }
        
        default:
            break;
    }
    return res;
}

#ifdef _OMINSTRUMENT
//#[ ignore
void OMAnimatedC::serializeAttributes(AOMSAttributes* aomsAttributes) const {
    aomsAttributes->addAttribute("x", x2String(myReal->x));
}

void OMAnimatedC::serializeRelations(AOMSRelations* aomsRelations) const {
    aomsRelations->addRelation("itsD", false, true);
    if(myReal->itsD)
        {
            aomsRelations->ADD_ITEM(myReal->itsD);
        }
    aomsRelations->addRelation("itsR", false, true);
    if(myReal->itsR)
        {
            aomsRelations->ADD_ITEM(myReal->itsR);
        }
}

void OMAnimatedC::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case C::s1:
        {
            s1_serializeStates(aomsState);
            break;
        }
        case C::s2:
        {
            s2_serializeStates(aomsState);
            break;
        }
        case C::s3:
        {
            s3_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedC::s3_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.s3");
}

void OMAnimatedC::s2_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.s2");
}

void OMAnimatedC::s1_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.s1");
}
//#]

IMPLEMENT_REACTIVE_META_P(C, Default, Default, false, OMAnimatedC)
#endif // _OMINSTRUMENT

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\C.cpp
*********************************************************************/
