/*********************************************************************
	Rhapsody	: 7.4 
	Login		: westphal
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: C
//!	Generated Date	: Wed, 16, Jan 2013  
	File Path	: DefaultComponent\DefaultConfig\C.h
*********************************************************************/

#ifndef C_H
#define C_H

//## auto_generated
#include <oxf\oxf.h>
//## auto_generated
#include <aom\aom.h>
//## auto_generated
#include "Default.h"
//## auto_generated
#include <oxf\omthread.h>
//## auto_generated
#include <oxf\omreactive.h>
//## auto_generated
#include <oxf\state.h>
//## auto_generated
#include <oxf\event.h>
//## link itsD
class D;

//## link itsR
class R;

//## package Default

//## class C
class C : public OMReactive {
    ////    Friends    ////
    
public :

#ifdef _OMINSTRUMENT
    friend class OMAnimatedC;
#endif // _OMINSTRUMENT

    ////    Constructors and destructors    ////
    
    //## auto_generated
    C(IOxfActive* theActiveContext = 0);
    
    //## auto_generated
    ~C();
    
    ////    Additional operations    ////
    
    //## auto_generated
    int getX() const;
    
    //## auto_generated
    void setX(int p_x);
    
    //## auto_generated
    D* getItsD() const;
    
    //## auto_generated
    void setItsD(D* p_D);
    
    //## auto_generated
    R* getItsR() const;
    
    //## auto_generated
    void setItsR(R* p_R);
    
    //## auto_generated
    virtual bool startBehavior();

protected :

    //## auto_generated
    void initStatechart();
    
    //## auto_generated
    void cleanUpRelations();
    
    ////    Attributes    ////
    
    int x;		//## attribute x
    
    ////    Relations and components    ////
    
    D* itsD;		//## link itsD
    
    R* itsR;		//## link itsR
    
    ////    Framework operations    ////

public :

    //## auto_generated
    void __setItsR(R* p_R);
    
    //## auto_generated
    void _setItsR(R* p_R);
    
    //## auto_generated
    void _clearItsR();
    
    ////    Framework    ////
    
    // rootState:
    //## statechart_method
    inline bool rootState_IN() const;
    
    //## statechart_method
    virtual void rootState_entDef();
    
    //## statechart_method
    virtual IOxfReactive::TakeEventStatus rootState_processEvent();
    
    // s3:
    //## statechart_method
    inline bool s3_IN() const;
    
    // s2:
    //## statechart_method
    inline bool s2_IN() const;
    
    // s1:
    //## statechart_method
    inline bool s1_IN() const;

protected :

//#[ ignore
    enum C_Enum {
        OMNonState = 0,
        s3 = 1,
        s2 = 2,
        s1 = 3
    };
    
    int rootState_subState;
    
    int rootState_active;
//#]
};

#ifdef _OMINSTRUMENT
//#[ ignore
class OMAnimatedC : virtual public AOMInstance {
    DECLARE_REACTIVE_META(C, OMAnimatedC)
    
    ////    Framework operations    ////
    
public :

    virtual void serializeAttributes(AOMSAttributes* aomsAttributes) const;
    
    virtual void serializeRelations(AOMSRelations* aomsRelations) const;
    
    //## statechart_method
    void rootState_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void s3_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void s2_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void s1_serializeStates(AOMSState* aomsState) const;
};
//#]
#endif // _OMINSTRUMENT

inline bool C::rootState_IN() const {
    return true;
}

inline bool C::s3_IN() const {
    return rootState_subState == s3;
}

inline bool C::s2_IN() const {
    return rootState_subState == s2;
}

inline bool C::s1_IN() const {
    return rootState_subState == s1;
}

#endif
/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\C.h
*********************************************************************/
