/********************************************************************
	Rhapsody	: 7.4 
	Login		: westphal
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: D
//!	Generated Date	: Wed, 16, Jan 2013  
	File Path	: DefaultComponent\DefaultConfig\D.cpp
*********************************************************************/

//#[ ignore
#define NAMESPACE_PREFIX

#define _OMSTATECHART_ANIMATED
//#]

//## auto_generated
#include "D.h"
//## link itsC
#include "C.h"
//## link itsR
#include "R.h"
//#[ ignore
#define Default_D_D_SERIALIZE OM_NO_OP
//#]

//## package Default

//## class D
D::D(IOxfActive* theActiveContext) {
    NOTIFY_REACTIVE_CONSTRUCTOR(D, D(), 0, Default_D_D_SERIALIZE);
    setActiveContext(theActiveContext, false);
    itsC = NULL;
    itsR = NULL;
    initStatechart();
}

D::~D() {
    NOTIFY_DESTRUCTOR(~D, true);
    cleanUpRelations();
}

C* D::getItsC() const {
    return itsC;
}

void D::setItsC(C* p_C) {
    itsC = p_C;
    if(p_C != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED("itsC", p_C, false, true);
        }
    else
        {
            NOTIFY_RELATION_CLEARED("itsC");
        }
}

R* D::getItsR() const {
    return itsR;
}

void D::setItsR(R* p_R) {
    _setItsR(p_R);
}

bool D::startBehavior() {
    bool done = false;
    done = OMReactive::startBehavior();
    return done;
}

void D::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
}

void D::cleanUpRelations() {
    if(itsC != NULL)
        {
            NOTIFY_RELATION_CLEARED("itsC");
            itsC = NULL;
        }
    if(itsR != NULL)
        {
            NOTIFY_RELATION_CLEARED("itsR");
            itsR = NULL;
        }
}

void D::__setItsR(R* p_R) {
    itsR = p_R;
    if(p_R != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED("itsR", p_R, false, true);
        }
    else
        {
            NOTIFY_RELATION_CLEARED("itsR");
        }
}

void D::_setItsR(R* p_R) {
    __setItsR(p_R);
}

void D::_clearItsR() {
    NOTIFY_RELATION_CLEARED("itsR");
    itsR = NULL;
}

void D::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        NOTIFY_TRANSITION_STARTED("0");
        NOTIFY_STATE_ENTERED("ROOT.s4");
        rootState_subState = s4;
        rootState_active = s4;
        NOTIFY_TRANSITION_TERMINATED("0");
    }
}

IOxfReactive::TakeEventStatus D::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        case s4:
        {
            if(IS_EVENT_TYPE_OF(F_Default_id))
                {
                    NOTIFY_TRANSITION_STARTED("1");
                    NOTIFY_STATE_EXITED("ROOT.s4");
                    //#[ transition 1 
                    getItsC()->setX(0);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.s5");
                    pushNullTransition();
                    rootState_subState = s5;
                    rootState_active = s5;
                    NOTIFY_TRANSITION_TERMINATED("1");
                    res = eventConsumed;
                }
            
            break;
        }
        case s5:
        {
            if(IS_EVENT_TYPE_OF(OMNullEventId))
                {
                    NOTIFY_TRANSITION_STARTED("2");
                    popNullTransition();
                    NOTIFY_STATE_EXITED("ROOT.s5");
                    //#[ transition 2 
                    getItsC()->GEN(E);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.s6");
                    rootState_subState = s6;
                    rootState_active = s6;
                    NOTIFY_TRANSITION_TERMINATED("2");
                    res = eventConsumed;
                }
            
            break;
        }
        
        default:
            break;
    }
    return res;
}

#ifdef _OMINSTRUMENT
//#[ ignore
void OMAnimatedD::serializeRelations(AOMSRelations* aomsRelations) const {
    aomsRelations->addRelation("itsC", false, true);
    if(myReal->itsC)
        {
            aomsRelations->ADD_ITEM(myReal->itsC);
        }
    aomsRelations->addRelation("itsR", false, true);
    if(myReal->itsR)
        {
            aomsRelations->ADD_ITEM(myReal->itsR);
        }
}

void OMAnimatedD::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case D::s4:
        {
            s4_serializeStates(aomsState);
            break;
        }
        case D::s5:
        {
            s5_serializeStates(aomsState);
            break;
        }
        case D::s6:
        {
            s6_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedD::s6_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.s6");
}

void OMAnimatedD::s5_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.s5");
}

void OMAnimatedD::s4_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.s4");
}
//#]

IMPLEMENT_REACTIVE_META_P(D, Default, Default, false, OMAnimatedD)
#endif // _OMINSTRUMENT

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\D.cpp
*********************************************************************/
