/*********************************************************************
	Rhapsody	: 7.4 
	Login		: westphal
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: D
//!	Generated Date	: Wed, 16, Jan 2013  
	File Path	: DefaultComponent\DefaultConfig\D.h
*********************************************************************/

#ifndef D_H
#define D_H

//## auto_generated
#include <oxf\oxf.h>
//## auto_generated
#include <aom\aom.h>
//## auto_generated
#include "Default.h"
//## auto_generated
#include <oxf\omthread.h>
//## auto_generated
#include <oxf\omreactive.h>
//## auto_generated
#include <oxf\state.h>
//## auto_generated
#include <oxf\event.h>
//## link itsC
class C;

//## link itsR
class R;

//## package Default

//## class D
class D : public OMReactive {
    ////    Friends    ////
    
public :

#ifdef _OMINSTRUMENT
    friend class OMAnimatedD;
#endif // _OMINSTRUMENT

    ////    Constructors and destructors    ////
    
    //## auto_generated
    D(IOxfActive* theActiveContext = 0);
    
    //## auto_generated
    ~D();
    
    ////    Additional operations    ////
    
    //## auto_generated
    C* getItsC() const;
    
    //## auto_generated
    void setItsC(C* p_C);
    
    //## auto_generated
    R* getItsR() const;
    
    //## auto_generated
    void setItsR(R* p_R);
    
    //## auto_generated
    virtual bool startBehavior();

protected :

    //## auto_generated
    void initStatechart();
    
    //## auto_generated
    void cleanUpRelations();
    
    ////    Relations and components    ////
    
    C* itsC;		//## link itsC
    
    R* itsR;		//## link itsR
    
    ////    Framework operations    ////

public :

    //## auto_generated
    void __setItsR(R* p_R);
    
    //## auto_generated
    void _setItsR(R* p_R);
    
    //## auto_generated
    void _clearItsR();
    
    ////    Framework    ////
    
    // rootState:
    //## statechart_method
    inline bool rootState_IN() const;
    
    //## statechart_method
    virtual void rootState_entDef();
    
    //## statechart_method
    virtual IOxfReactive::TakeEventStatus rootState_processEvent();
    
    // s6:
    //## statechart_method
    inline bool s6_IN() const;
    
    // s5:
    //## statechart_method
    inline bool s5_IN() const;
    
    // s4:
    //## statechart_method
    inline bool s4_IN() const;

protected :

//#[ ignore
    enum D_Enum {
        OMNonState = 0,
        s6 = 1,
        s5 = 2,
        s4 = 3
    };
    
    int rootState_subState;
    
    int rootState_active;
//#]
};

#ifdef _OMINSTRUMENT
//#[ ignore
class OMAnimatedD : virtual public AOMInstance {
    DECLARE_REACTIVE_META(D, OMAnimatedD)
    
    ////    Framework operations    ////
    
public :

    virtual void serializeRelations(AOMSRelations* aomsRelations) const;
    
    //## statechart_method
    void rootState_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void s6_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void s5_serializeStates(AOMSState* aomsState) const;
    
    //## statechart_method
    void s4_serializeStates(AOMSState* aomsState) const;
};
//#]
#endif // _OMINSTRUMENT

inline bool D::rootState_IN() const {
    return true;
}

inline bool D::s6_IN() const {
    return rootState_subState == s6;
}

inline bool D::s5_IN() const {
    return rootState_subState == s5;
}

inline bool D::s4_IN() const {
    return rootState_subState == s4;
}

#endif
/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\D.h
*********************************************************************/
