/********************************************************************
	Rhapsody	: 7.4 
	Login		: westphal
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: R
//!	Generated Date	: Wed, 16, Jan 2013  
	File Path	: DefaultComponent\DefaultConfig\R.cpp
*********************************************************************/

//#[ ignore
#define NAMESPACE_PREFIX
//#]

//## auto_generated
#include "R.h"
//#[ ignore
#define Default_R_R_SERIALIZE OM_NO_OP
//#]

//## package Default

//## class R
R::~R() {
    NOTIFY_DESTRUCTOR(~R, true);
}

C* R::getItsC() const {
    return (C*) &itsC;
}

D* R::getItsD() const {
    return (D*) &itsD;
}

bool R::startBehavior() {
    bool done = true;
    done &= itsC.startBehavior();
    done &= itsD.startBehavior();
    done &= OMReactive::startBehavior();
    return done;
}

void R::initRelations() {
    itsC._setItsR(this);
    itsD._setItsR(this);
}

void R::destroy() {
    itsC.destroy();
    itsD.destroy();
    OMReactive::destroy();
}

R::R(IOxfActive* theActiveContext) {
    NOTIFY_REACTIVE_CONSTRUCTOR(R, R(), 0, Default_R_R_SERIALIZE);
    setActiveContext(theActiveContext, false);
    {
        {
            itsC.setShouldDelete(false);
        }
        itsC.setActiveContext(theActiveContext, false);
        {
            itsD.setShouldDelete(false);
        }
        itsD.setActiveContext(theActiveContext, false);
    }
    initRelations();
}

#ifdef _OMINSTRUMENT
//#[ ignore
void OMAnimatedR::serializeRelations(AOMSRelations* aomsRelations) const {
    aomsRelations->addRelation("itsC", true, true);
    aomsRelations->ADD_ITEM(&myReal->itsC);
    aomsRelations->addRelation("itsD", true, true);
    aomsRelations->ADD_ITEM(&myReal->itsD);
}
//#]

IMPLEMENT_REACTIVE_META_SIMPLE_P(R, Default, Default, false, OMAnimatedR)
#endif // _OMINSTRUMENT

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\R.cpp
*********************************************************************/
