/********************************************************************
	Rhapsody	: 7.4 
	Login		: westphal
	Component	: DefaultComponent 
	Configuration 	: DefaultConfig
	Model Element	: C
//!	Generated Date	: Wed, 16, Jan 2013  
	File Path	: DefaultComponent\DefaultConfig\C.cpp
*********************************************************************/

//#[ ignore
#define NAMESPACE_PREFIX

#define _OMSTATECHART_ANIMATED
//#]

//## auto_generated
#include "C.h"
//#[ ignore
#define Default_C_C_SERIALIZE OM_NO_OP
//#]

//## package Default

//## class C
C::C(IOxfActive* theActiveContext) {
    NOTIFY_REACTIVE_CONSTRUCTOR(C, C(), 0, Default_C_C_SERIALIZE);
    setActiveContext(theActiveContext, false);
    {
        for (int i = 0; i < 13; i++) 
        {
            itsD[i].setShouldDelete(false);
            itsD[i].setActiveContext(theActiveContext, false);
        }
        
    }
    itsD_1 = NULL;
    initRelations();
    initStatechart();
}

C::~C() {
    NOTIFY_DESTRUCTOR(~C, true);
    cleanUpRelations();
}

int C::getItsD() const {
    int iter = 0;
    return iter;
}

D* C::getItsD_1() const {
    return itsD_1;
}

void C::setItsD_1(D* p_D) {
    itsD_1 = p_D;
    if(p_D != NULL)
        {
            NOTIFY_RELATION_ITEM_ADDED("itsD_1", p_D, false, true);
        }
    else
        {
            NOTIFY_RELATION_CLEARED("itsD_1");
        }
}

bool C::startBehavior() {
    bool done = true;
    {
        int iter = 0;
        while (iter < 13){
            done &= (((D*)&itsD[iter]))->startBehavior();
            iter++;
        }
    }
    done &= OMReactive::startBehavior();
    return done;
}

void C::initRelations() {
    {
        int iter = 0;
        while (iter < 13){
            ((D*)&itsD[iter])->_setItsC(this);
            iter++;
        }
    }
}

void C::initStatechart() {
    rootState_subState = OMNonState;
    rootState_active = OMNonState;
}

void C::cleanUpRelations() {
    if(itsD_1 != NULL)
        {
            NOTIFY_RELATION_CLEARED("itsD_1");
            itsD_1 = NULL;
        }
}

void C::destroy() {
    {
        int iter = 0;
        while (iter < 13){
            (((D*)&itsD[iter]))->destroy();
            iter++;
        }
    }
    OMReactive::destroy();
}

void C::rootState_entDef() {
    {
        NOTIFY_STATE_ENTERED("ROOT");
        NOTIFY_TRANSITION_STARTED("0");
        NOTIFY_STATE_ENTERED("ROOT.state_0");
        rootState_subState = state_0;
        rootState_active = state_0;
        NOTIFY_TRANSITION_TERMINATED("0");
    }
}

IOxfReactive::TakeEventStatus C::rootState_processEvent() {
    IOxfReactive::TakeEventStatus res = eventNotConsumed;
    switch (rootState_active) {
        case state_0:
        {
            if(IS_EVENT_TYPE_OF(E_Default_id))
                {
                    NOTIFY_TRANSITION_STARTED("1");
                    NOTIFY_STATE_EXITED("ROOT.state_0");
                    //#[ transition 1 
                    getItsD()->GEN(F);
                    //#]
                    NOTIFY_STATE_ENTERED("ROOT.state_1");
                    rootState_subState = state_1;
                    rootState_active = state_1;
                    NOTIFY_TRANSITION_TERMINATED("1");
                    res = eventConsumed;
                }
            
            break;
        }
        case state_1:
        {
            if(IS_EVENT_TYPE_OF(G_Default_id))
                {
                    NOTIFY_TRANSITION_STARTED("2");
                    NOTIFY_STATE_EXITED("ROOT.state_1");
                    NOTIFY_STATE_ENTERED("ROOT.state_0");
                    rootState_subState = state_0;
                    rootState_active = state_0;
                    NOTIFY_TRANSITION_TERMINATED("2");
                    res = eventConsumed;
                }
            
            break;
        }
        default:
            break;
    }
    return res;
}

#ifdef _OMINSTRUMENT
//#[ ignore
void OMAnimatedC::serializeRelations(AOMSRelations* aomsRelations) const {
    aomsRelations->addRelation("itsD", true, false);
    {
        int iter = 0;
        while (iter < 13){
            aomsRelations->ADD_ITEM(((D*)&myReal->itsD[iter]));
            iter++;
        }
    }
    aomsRelations->addRelation("itsD_1", false, true);
    if(myReal->itsD_1)
        {
            aomsRelations->ADD_ITEM(myReal->itsD_1);
        }
}

void OMAnimatedC::rootState_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT");
    switch (myReal->rootState_subState) {
        case C::state_0:
        {
            state_0_serializeStates(aomsState);
            break;
        }
        case C::state_1:
        {
            state_1_serializeStates(aomsState);
            break;
        }
        default:
            break;
    }
}

void OMAnimatedC::state_1_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.state_1");
}

void OMAnimatedC::state_0_serializeStates(AOMSState* aomsState) const {
    aomsState->addState("ROOT.state_0");
}
//#]

IMPLEMENT_REACTIVE_META_P(C, Default, Default, false, OMAnimatedC)
#endif // _OMINSTRUMENT

/*********************************************************************
	File Path	: DefaultComponent\DefaultConfig\C.cpp
*********************************************************************/
